### eevee-publish-webpack-plugin

> 提供对接eevee的资源信息上传的 webpack插件

##### 用法

webpack@4

```javascript
var { PublishWebpackPlugin } = require('eevee-publish-webpack-plugin');
module.exports = {
  entry: {
    index: [resolve(__dirname, './demo/index.js')],
    sub: [resolve(__dirname, './demo/sub.js')],
  },
  output: {
    path: resolve(__dirname, './dist'),
    publicPath: 'https://img.maihaoche.com',
  },
  plugins:[
    new PublishWebpackPlugin({ server: 'http://hhhhh.haimaiche.net/api', projectId: 22, env: process.PUBLISH_ENV }),
  ],
}
```

webpack@2-3

```javascript
var { PublishWebpackPluginV3: PublishWebpackPlugin } = require('eevee-publish-webpack-plugin');
module.exports = {
  entry: {
    index: [resolve(__dirname, './demo/index.js')],
    sub: [resolve(__dirname, './demo/sub.js')],
  },
  output: {
    path: resolve(__dirname, './dist'),
    publicPath: 'https://img.maihaoche.com',
  },
  plugins:[
    new PublishWebpackPlugin({ server: 'http://hhhhh.haimaiche.net/api', projectId: 22, env: process.PUBLISH_ENV }),
  ],
}
```

针对相对javascript排序的朋友

```javascript
 new PublishWebpackPlugin({
   ... 你的其他配置
  handleJavascripts(javascripts) {
     const sort = ['vendor', 'manifest', 'app']
     return [
       ...javascripts.filter(i => /vendor/.test(i)),
       ...javascripts.filter(i => /manifest/.test(i)),
       ...javascripts.filter(i => /app/.test(i))
     ]
   },
 })
```

参数

|字段名|说明|默认值|
|-|-|-|
|env|环境变量，用于读取eevee本地token|无|
|server|eevee的服务器地址|`https://eevee.maihaoche.com`|
|projectId|项目id|无|
|publicPath|用于设置打包资源的前缀|webpack.config.output.publicPath|
|handleJavascripts|用于对javascript的数组做后置处理|old => old|
|handleStyles|用于对styles的数组做后置处理|old => old|
