import { Compiler } from 'webpack';
import { Uploader } from 'eevee-core';
export interface PublishWebpackPluginOptions {
    uploaders: Uploader[];
    env: string;
    server: string;
    projectId?: number;
    appId?: number;
    publicPath?: string;
    handleJavascripts: (_: string[]) => string[];
    handleStyles: (_: string[]) => string[];
}
declare class BasePublishWebpackPlugin {
    server: string;
    pid?: number;
    aid: number;
    env: string;
    uploaders: Uploader[];
    publicPath?: string;
    handleJavascripts: (_: string[]) => string[];
    handleStyles: (_: string[]) => string[];
    constructor(options: PublishWebpackPluginOptions);
    publishToServer(keys: string[], chunkFactory: ((k: string) => any), hash: string, prefix: string): Promise<any>;
}
export declare class PublishWebpackPlugin extends BasePublishWebpackPlugin {
    apply(compile: Compiler): void;
}
export declare class PublishWebpackPluginV3 extends BasePublishWebpackPlugin {
    apply(compile: Compiler): void;
}
export {};
