"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var eevee_core_1 = require("eevee-core");
var path_1 = require("path");
var url_1 = require("url");
var PluginName = 'EEVEE_PUBLISH_WEBPACK_PLUGIN';
var joinUrl = function (prefix, path) {
    try {
        var url = new url_1.URL(prefix);
        return url.protocol + "//" + path_1.join(url.host, url.pathname, path);
    }
    catch (error) {
        return path_1.join(prefix, path);
    }
};
var BasePublishWebpackPlugin = /** @class */ (function () {
    function BasePublishWebpackPlugin(options) {
        var server = options.server, publicPath = options.publicPath, projectId = options.projectId, env = options.env, uploaders = options.uploaders, handleJavascripts = options.handleJavascripts, handleStyles = options.handleStyles;
        this.env = env || '';
        this.server = server;
        this.pid = projectId;
        this.publicPath = publicPath;
        this.uploaders = uploaders;
        this.handleJavascripts = handleJavascripts || (function (old) { return old; });
        this.handleStyles = handleStyles || (function (old) { return old; });
    }
    BasePublishWebpackPlugin.prototype.publishToServer = function (keys, chunkFactory, hash, prefix) {
        var resources = keys.reduce(function (pre, key) {
            var chunk = chunkFactory(key);
            var files = chunk.files;
            var styles = files.filter(function (item) { return /\.css$/.test(item); }).map(function (item) { return joinUrl(prefix, item); });
            var javascripts = files.filter(function (item) { return /\.js$/.test(item); }).map(function (item) { return joinUrl(prefix, item); });
            pre.styles = pre.styles.concat(styles);
            pre.javascripts = pre.javascripts.concat(javascripts);
            return pre;
        }, {
            styles: [],
            javascripts: [],
            hash: hash,
            server: this.server,
            projectId: this.pid || 0,
            env: this.env,
        });
        resources.javascripts = this.handleJavascripts(resources.javascripts);
        resources.styles = this.handleStyles(resources.styles);
        return eevee_core_1.publish(resources, this.uploaders);
    };
    return BasePublishWebpackPlugin;
}());
var PublishWebpackPlugin = /** @class */ (function (_super) {
    __extends(PublishWebpackPlugin, _super);
    function PublishWebpackPlugin() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PublishWebpackPlugin.prototype.apply = function (compile) {
        var _this = this;
        compile.hooks.afterEmit.tapAsync(PluginName, function (stats) { return __awaiter(_this, void 0, void 0, function () {
            var hash, namedChunks, keys, prefix;
            return __generator(this, function (_a) {
                hash = stats.hash;
                namedChunks = stats.namedChunks;
                keys = Array.from(namedChunks.keys());
                prefix = this.publicPath || stats.outputOptions.publicPath || '';
                this.publishToServer(keys, function (key) {
                    return namedChunks.get(key);
                }, hash, prefix);
                return [2 /*return*/];
            });
        }); });
    };
    return PublishWebpackPlugin;
}(BasePublishWebpackPlugin));
exports.PublishWebpackPlugin = PublishWebpackPlugin;
var PublishWebpackPluginV3 = /** @class */ (function (_super) {
    __extends(PublishWebpackPluginV3, _super);
    function PublishWebpackPluginV3() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PublishWebpackPluginV3.prototype.apply = function (compile) {
        var _this = this;
        var publicPath = this.publicPath;
        compile.plugin('after-emit', function (compilation, callback) { return __awaiter(_this, void 0, void 0, function () {
            var namedChunks, hash, keys, prefix;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        namedChunks = compilation.namedChunks;
                        hash = compilation.hash;
                        keys = Object.keys(namedChunks);
                        prefix = publicPath || compilation.outputOptions.publicPath || '';
                        return [4 /*yield*/, this.publishToServer(keys, function (key) {
                                return namedChunks[key];
                            }, hash, prefix)];
                    case 1:
                        _a.sent();
                        callback();
                        return [2 /*return*/];
                }
            });
        }); });
    };
    return PublishWebpackPluginV3;
}(BasePublishWebpackPlugin));
exports.PublishWebpackPluginV3 = PublishWebpackPluginV3;
